Subject: [mpls] Use of leaf-lists in draft-ietf-mpls-static-yang

From: Aidan Copeland <[email-masked]>
Date: Wed, 29 Mar 2017 15:30:07 +0000

Hi Tarek, all,

I think that there is an error in the use of a leaf-list to represent the set of outgoing MPLS labels to impose for an outgoing path.

RFC7950, section 7.7, states

In configuration data, the values in a leaf-list MUST be unique.

This means that a leaf-list is not suitable to represent a label stack, where the same label value may be used more than once.

I think the best solution is instead to specify the set of outgoing labels as a list of outgoing label containers, keyed by label index and containing the outgoing label value.

Do you agree with this, or do you think a different mechanism would be better?

Regards

Aidan

---

From: "Tarek Saad (tsaad)" <[email-masked]>
Date: Fri, 31 Mar 2017 13:53:50 +0000

Hi Aidan,

You are right. Indeed, it is permissible the same labels values can repeat in the label stack and thus the leaf-list is not suitable. I’ll look into this and we’ll update it the model.
Thanks for reporting it.

Regards,
Tarek

On 2017-03-29, 10:30 AM, "Aidan Copeland" <[email-masked]<mailto:[email-masked]>> wrote:

Hi Tarek, all,

Regards

Aidan

---

From: t.petch <[email-masked]>
Date: Fri, 31 Mar 2017 17:11:07 +0100

---- Original Message -----
From: "Tarek Saad (tsaad)" <[email-masked]>
To: "Aidan Copeland" <[email-masked]>;
<[email-masked]>; <[email-masked]>
Sent: Friday, March 31, 2017 2:53 PM

> Hi Aidan,
>
> You are right. Indeed, it is permissible the same labels values can
repeat in the label stack and thus the leaf-list is not suitable. I’ll
look into this and we’ll update it the model.
> Thanks for reporting it.

The logic is that individual entries in a list can be separately
edited -which being 'configuration' implies that they may be - and so
must have a unique identifier for NETCONF to use.

The usual solution to this, in a database, is to introduce an additional
'column' purely to provide that unique identifier, often an integer.

Incidentally, your reference for YANG is to V1.0 which always makes me
wonder if it will work with YANG V1.1:-)

Tom Petch

> Regards,
> Tarek
>
> On 2017-03-29, 10:30 AM, "Aidan Copeland"
<[email-masked]<mailto:[email-masked]>>
wrote:
>
> Hi Tarek, all,
>
> I think that there is an error in the use of a leaf-list to represent
the set of outgoing MPLS labels to impose for an outgoing path.
> This means that a leaf-list is not suitable to represent a label
stack, where the same label value may be used more than once.
>
> I think the best solution is instead to specify the set of outgoing
labels as a list of outgoing label containers, keyed by label index and
containing the outgoing label value.
> Do you agree with this, or do you think a different mechanism would be
better?

------------------------------------------------------------------------
--------

> _______________________________________________
> mpls mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mpls
>